
import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import javax.sound.midi.*;

public class Preference extends JDialog implements ActionListener {
	Cadre cadre;

	JButton bouton_OK = new JButton(Logo.messages.getString("ok"));

	JButton bouton_CANCEL = new JButton(Logo.messages.getString("annuler"));

	JPanel panneau_bouton = new JPanel();

	JTabbedPane jt = new JTabbedPane();

	JPanel panneau_langue = new JPanel();

	ButtonGroup buttonGroup3 = new ButtonGroup(); //Pour les images de tortue

	String lang[] = { Logo.messages.getString("francais"),
			Logo.messages.getString("anglais"),
			Logo.messages.getString("gallois"),
			Logo.messages.getString("espagnol"),
			Logo.messages.getString("portugais"),
			Logo.messages.getString("esperanto") };

	JList jl_langues = new JList(lang); //Pour les diffrentes langues

	JScrollPane js_langues = new JScrollPane(jl_langues);

	ButtonGroup buttonGroup2 = new ButtonGroup();

	JPanel panneau_tortue = new JPanel();

	Icone[] icone = new Icone[7]; //POur les vignettes

	JScrollPane js = new JScrollPane();

	GridBagLayout gridBagLayout2 = new GridBagLayout();

	JCheckBox java = new JCheckBox();

	JCheckBox windows = new JCheckBox();

	JCheckBox motif = new JCheckBox();

	JLabel Langue = new JLabel(Logo.messages.getString("langue"));

	JLabel Aspect = new JLabel(Logo.messages.getString("aspect"));

	GridBagLayout gridBagLayout3 = new GridBagLayout();

	JLabel vitesse_defilement = new JLabel(Logo.messages.getString("vitesse"));

	JLabel lent = new JLabel(Logo.messages.getString("lent"));

	JLabel rapide = new JLabel(Logo.messages.getString("vite"));

	JSlider jSlider1 = new JSlider();

	JPanel panneau_options = new JPanel();

	JCheckBox effacer_editeur = new JCheckBox(Logo.messages
			.getString("effacer_editeur"));

	GridBagLayout gridBagLayout4 = new GridBagLayout();

	JLabel nb_tortues = new JLabel(Logo.messages.getString("nb_tortues"));

	JLabel epaisseur_crayon = new JLabel(Logo.messages
			.getString("epaisseur_crayon"));

	JLabel forme_crayon = new JLabel(Logo.messages.getString("forme_crayon"));

	Object[] carre_rond = { Logo.messages.getString("carre"),
			Logo.messages.getString("rond") };

	JComboBox jc = new JComboBox(carre_rond);

	JTextField tortues = new JTextField();

	JTextField epaisseur = new JTextField();

	JLabel dimension_dessin = new JLabel(Logo.messages
			.getString("taille_dessin"));
	JPanel taille_dessin = new JPanel();
	JTextField largeur = new JTextField(String.valueOf(Logo.largeur_dessin));
	JLabel labelx = new JLabel("x");
	JTextField hauteur = new JTextField(String.valueOf(Logo.hauteur_dessin));
	JLabel label_memoire=new JLabel(Logo.messages.getString("memoire"));
	JTextField memoire=new JTextField(String.valueOf(Logo.tmp_memoire));
	JLabel label_qualite=new JLabel(Logo.messages.getString("qualite_dessin"));
	Object[] choix_qualite={Logo.messages.getString("normal"),Logo.messages.getString("haut"),Logo.messages.getString("bas")};
	JComboBox jc_qualite=new JComboBox(choix_qualite);
	JPanel panneau_son = new JPanel();

	JLabel instruments_dispo = new JLabel(Logo.messages
			.getString("instruments_dispo"));

	JList instrument = new JList();

	JScrollPane scroll_son;

	Panneau_Police panneau_police = new Panneau_Police();
	Panneau_Coloration panneau_coloration=new Panneau_Coloration();
	
	public Preference(Cadre cadre) {
		bouton_CANCEL.setFont(Logo.police);
		bouton_OK.setFont(Logo.police);
		jt.setFont(Logo.police);
		Langue.setFont(Logo.police);
		Aspect.setFont(Logo.police);
		vitesse_defilement.setFont(Logo.police);
		lent.setFont(Logo.police);
		rapide.setFont(Logo.police);
		java.setFont(Logo.police);
		windows.setFont(Logo.police);
		motif.setFont(Logo.police);
		nb_tortues.setFont(Logo.police);
		epaisseur_crayon.setFont(Logo.police);
		forme_crayon.setFont(Logo.police);
		effacer_editeur.setFont(Logo.police);
		dimension_dessin.setFont(Logo.police);
		instruments_dispo.setFont(Logo.police);
		label_memoire.setFont(Logo.police);
		label_qualite.setFont(Logo.police);
		jc.setFont(Logo.police);
		tortues.setFont(Logo.police);
		epaisseur.setFont(Logo.police);
		largeur.setFont(Logo.police);
		hauteur.setFont(Logo.police);
		memoire.setFont(Logo.police);
		jc_qualite.setFont(Logo.police);
	
		jl_langues.setCellRenderer(new Contenu());
		buttonGroup2.add(java);
		buttonGroup2.add(motif);
		buttonGroup2.add(windows);

		this.cadre = cadre;
		for (int i = 0; i < 7; i++) {
			icone[i] = new Icone(i);
			icone[i].setText("");
			buttonGroup3.add(icone[i]);
		}
		try {
			jbInit();
		} catch (Exception e) {
			e.printStackTrace();
		}
		jl_langues.setSelectionBackground(Color.orange);
		jl_langues.setSelectedIndex(Logo.langage);
		jc.setSelectedIndex(Logo.forme_crayon);
		if (Logo.effacer_dessin)
			effacer_editeur.setSelected(true);
		epaisseur.setText(String.valueOf(Logo.epaisseur_max));
		tortues.setText(String.valueOf(Logo.tortues));

		jSlider1.setValue(Logo.vitesse);
		this.setModal(false);
		this.setResizable(true);
		this.setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
		setLocation(100,100);
	}

	private void jbInit() throws Exception {
		Color violet = new Color(169, 169, 246);
		panneau_langue.setLayout(gridBagLayout3);
		jl_langues.setBackground(violet);
		jl_langues.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		panneau_langue.setBackground(violet);
		panneau_langue.setFont(new java.awt.Font("DialogInput", 0, 12));
		jt.setBackground(Color.pink);
		jt.setFont(new java.awt.Font("DialogInput", 1, 12));
		panneau_tortue.setBackground(violet);
		panneau_tortue.setLayout(gridBagLayout2);
		panneau_bouton.setBackground(violet);
		bouton_OK.setBackground(Color.orange);
		bouton_CANCEL.setBackground(Color.orange);
		this.getContentPane().setBackground(violet);
		this.setTitle("");
		java.setBackground(violet);
		java.setActionCommand(Logo.messages.getString("metal"));
		java.setHorizontalAlignment(SwingConstants.LEFT);
		java.setHorizontalTextPosition(SwingConstants.LEFT);
		java.setText(Logo.messages.getString("metal"));
		windows.setBackground(violet);
		windows.setActionCommand(Logo.messages.getString("windows"));
		windows.setHorizontalAlignment(SwingConstants.LEFT);
		windows.setHorizontalTextPosition(SwingConstants.LEFT);
		windows.setText(Logo.messages.getString("windows"));
		windows.setVerticalAlignment(SwingConstants.CENTER);
		motif.setBackground(violet);
		motif.setActionCommand(Logo.messages.getString("motif"));
		motif.setHorizontalAlignment(SwingConstants.LEFT);
		motif.setHorizontalTextPosition(SwingConstants.LEFT);
		motif.setText(Logo.messages.getString("motif"));
		Langue.setForeground(Color.red);
		Langue.setOpaque(true);
		Langue.setHorizontalAlignment(SwingConstants.CENTER);
		Langue.setHorizontalTextPosition(SwingConstants.LEFT);
		Langue.setText(Logo.messages.getString("langue"));
		Aspect.setForeground(Color.red);
		Aspect.setOpaque(true);
		Aspect.setHorizontalAlignment(SwingConstants.CENTER);
		Aspect.setHorizontalTextPosition(SwingConstants.LEFT);
		Aspect.setText(Logo.messages.getString("aspect"));
		lent.setBackground(Color.lightGray);
		lent.setForeground(Color.red);
		lent.setOpaque(true);
		lent.setToolTipText("");
		lent.setHorizontalAlignment(SwingConstants.RIGHT);
		lent.setHorizontalTextPosition(SwingConstants.RIGHT);
		lent.setText(Logo.messages.getString("lent"));
		lent.setVerticalAlignment(SwingConstants.BOTTOM);
		lent.setVerticalTextPosition(SwingConstants.BOTTOM);
		rapide.setBackground(Color.lightGray);
		rapide.setForeground(Color.red);
		rapide.setDebugGraphicsOptions(0);
		rapide.setOpaque(true);
		rapide.setHorizontalAlignment(SwingConstants.LEFT);
		rapide.setHorizontalTextPosition(SwingConstants.LEFT);
		rapide.setText(Logo.messages.getString("vite"));
		rapide.setVerticalAlignment(SwingConstants.BOTTOM);
		rapide.setVerticalTextPosition(SwingConstants.BOTTOM);
		jSlider1.setPaintLabels(false);
		jSlider1.setBackground(Color.lightGray);
		jSlider1.setDebugGraphicsOptions(0);
		jt.add(panneau_langue, "General");
		panneau_langue.add(Langue, new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0,
				GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(
						10, 10, 0, 10), 0, 0));
		panneau_langue.add(js_langues, new GridBagConstraints(0, 1, 1, 3, 1.0,
				1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
				new Insets(10, 10, 10, 10), 0, 0));
		panneau_langue.add(Aspect, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0,
				GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(
						10, 10, 0, 10), 0, 0));
		panneau_langue.add(java, new GridBagConstraints(1, 1, 1, 1, 1.0, 1.0,
				GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(
						0, 0, 0, 0), 0, 0));
		panneau_langue.add(windows, new GridBagConstraints(1, 2, 1, 1, 1.0,
				1.0, GridBagConstraints.CENTER, GridBagConstraints.NONE,
				new Insets(0, 0, 0, 0), 0, 0));
		panneau_langue.add(motif, new GridBagConstraints(1, 3, 1, 1, 1.0, 1.0,
				GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(
						0, 0, 0, 0), 0, 0));

		panneau_langue.add(vitesse_defilement, new GridBagConstraints(0, 4, 1,
				1, 1.0, 0.5, GridBagConstraints.EAST, GridBagConstraints.BOTH,
				new Insets(0, 0, 0, 0), 0, 0));
		panneau_langue.add(lent, new GridBagConstraints(1, 5, 1, 1, 1.0, 0.5,
				GridBagConstraints.EAST, GridBagConstraints.BOTH, new Insets(0,
						0, 0, 0), 0, 0));
		panneau_langue.add(rapide, new GridBagConstraints(0, 5, 1, 1, 1.0, 0.5,
				GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(0,
						0, 0, 0), 0, 0));
		panneau_langue.add(jSlider1, new GridBagConstraints(0, 6, 2, 1, 1.0,
				1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
				new Insets(0, 0, 10, 0), 0, 0));

		panneau_tortue.add(icone[5], new GridBagConstraints(2, 1, 1, 1, 1.0,
				1.0, GridBagConstraints.CENTER, GridBagConstraints.NONE,
				new Insets(5, 5, 5, 5), 0, 0));
		panneau_tortue.add(icone[3], new GridBagConstraints(0, 1, 1, 1, 1.0,
				1.0, GridBagConstraints.CENTER, GridBagConstraints.NONE,
				new Insets(5, 5, 5, 5), 0, 0));
		panneau_tortue.add(icone[4], new GridBagConstraints(1, 1, 1, 1, 1.0,
				1.0, GridBagConstraints.CENTER, GridBagConstraints.NONE,
				new Insets(5, 5, 5, 5), 0, 0));
		panneau_tortue.add(icone[2], new GridBagConstraints(2, 0, 1, 1, 1.0,
				1.0, GridBagConstraints.CENTER, GridBagConstraints.NONE,
				new Insets(5, 5, 5, 5), 0, 0));
		panneau_tortue.add(icone[1], new GridBagConstraints(1, 0, 1, 1, 1.0,
				1.0, GridBagConstraints.CENTER, GridBagConstraints.NONE,
				new Insets(5, 5, 5, 5), 0, 0));
		panneau_tortue.add(icone[6], new GridBagConstraints(0, 2, 1, 1, 1.0,
				1.0, GridBagConstraints.CENTER, GridBagConstraints.NONE,
				new Insets(5, 5, 5, 5), 0, 0));
		panneau_tortue.add(icone[0], new GridBagConstraints(0, 0, 1, 1, 1.0,
				1.0, GridBagConstraints.CENTER, GridBagConstraints.NONE,
				new Insets(5, 5, 5, 5), 0, 0));

		js.getViewport().add(panneau_tortue);

		jt.add(js, Logo.messages.getString("choix_tortue"));

		panneau_options.setBackground(violet);
		panneau_options.setLayout(gridBagLayout4);
		taille_dessin.add(hauteur);
		taille_dessin.add(labelx);
		taille_dessin.add(largeur);
		taille_dessin.setBackground(violet);
		effacer_editeur.setBackground(violet);
		jc_qualite.setSelectedIndex(Logo.qualite);
		panneau_options.add(nb_tortues, new GridBagConstraints(0, 0, 1, 1, 1.0,
				1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
				new Insets(10, 10, 0, 10), 0, 0));
		panneau_options.add(tortues, new GridBagConstraints(1, 0, 1, 1, 1.0,
				1.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL,
				new Insets(10, 10, 0, 10), 0, 0));
		panneau_options.add(epaisseur_crayon, new GridBagConstraints(0, 1, 1,
				1, 1.0, 1.0, GridBagConstraints.CENTER,
				GridBagConstraints.BOTH, new Insets(10, 10, 0, 10), 0, 0));
		panneau_options.add(epaisseur, new GridBagConstraints(1, 1, 1, 1, 1.0,
				1.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL,
				new Insets(10, 10, 0, 10), 0, 0));
		panneau_options.add(forme_crayon, new GridBagConstraints(0, 2, 1, 1,
				1.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
				new Insets(10, 10, 0, 10), 0, 0));
		panneau_options.add(jc, new GridBagConstraints(1, 2, 1, 1, 1.0, 1.0,
				GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL,
				new Insets(10, 10, 0, 10), 0, 0));
		panneau_options.add(dimension_dessin, new GridBagConstraints(0, 3, 1,
				1, 1.0, 1.0, GridBagConstraints.CENTER,
				GridBagConstraints.BOTH, new Insets(10, 10, 0, 10), 0, 0));
		panneau_options.add(taille_dessin, new GridBagConstraints(1, 3, 1, 1,
				1.0, 1.0, GridBagConstraints.CENTER,
				GridBagConstraints.HORIZONTAL, new Insets(10, 0, 0, 0), 0, 0));
		panneau_options.add(label_memoire, new GridBagConstraints(0, 4, 1,
				1, 1.0, 1.0, GridBagConstraints.CENTER,
				GridBagConstraints.BOTH, new Insets(10, 10, 0, 10), 0, 0));
		panneau_options.add(memoire, new GridBagConstraints(1, 4, 1, 1,
				1.0, 1.0, GridBagConstraints.CENTER,
				GridBagConstraints.HORIZONTAL, new Insets(10, 0, 0, 0), 0, 0));
		panneau_options.add(label_qualite, new GridBagConstraints(0, 5, 1,
				1, 1.0, 1.0, GridBagConstraints.CENTER,
				GridBagConstraints.BOTH, new Insets(10, 10, 0, 10), 0, 0));
		panneau_options.add(jc_qualite, new GridBagConstraints(1, 5, 1, 1,
				1.0, 1.0, GridBagConstraints.CENTER,
				GridBagConstraints.NONE, new Insets(10, 0, 0, 0), 0, 0));
		panneau_options.add(effacer_editeur, new GridBagConstraints(0, 6, 2, 1,
				1.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
				new Insets(10, 0, 0, 0), 0, 0));

		jt.add(panneau_options, Logo.messages.getString("options"));

		this.getContentPane().setLayout(new BorderLayout());
		getContentPane().add(jt, BorderLayout.CENTER);
		panneau_bouton.add(bouton_CANCEL);
		panneau_bouton.add(bouton_OK);
		getContentPane().add(panneau_bouton, BorderLayout.SOUTH);
		bouton_OK.addActionListener(this);
		bouton_CANCEL.addActionListener(this);

		jt.add(panneau_son, Logo.messages.getString("son"));
		panneau_son.setBackground(violet);
		instruments_dispo.setBackground(violet);
		panneau_son.setLayout(new BorderLayout());
		panneau_son.add(instruments_dispo, BorderLayout.NORTH);

		try {
			Synthesizer synthesizer = MidiSystem.getSynthesizer();
			synthesizer.open();
			Instrument[] in = synthesizer.getAvailableInstruments();
			Object[] ob = new Object[in.length];
			for (int i = 0; i < in.length; i++) {
				ob[i] = i + " " + in[i].getName();
			}
			synthesizer.close();
			instrument = new JList(ob);
			instrument.setFont(Logo.police);
			instrument.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			instrument.setSelectedIndex(cadre.son.getInstrument());
			scroll_son = new JScrollPane(instrument);
			panneau_son.add(scroll_son, BorderLayout.CENTER);
		} catch (MidiUnavailableException e) {
			Object[] ob = { Logo.messages.getString("probleme_midi") };
			instrument = new JList(ob);
			scroll_son = new JScrollPane(instrument);
			panneau_son.add(scroll_son, BorderLayout.CENTER);
		}

		jt.add(panneau_police, Logo.messages.getString("police"));
		JScrollPane js_coloration=new JScrollPane(panneau_coloration);
		jt.add(js_coloration, Logo.messages.getString("coloration"));
		setVisible(true);
		pack();
	}

	public void actionPerformed(ActionEvent e) {
		cadre.menulistener.pf = null;
		if (e.getActionCommand().equals(Logo.messages.getString("ok"))) {
			// Si on a chang la langue
			int indicateur = jl_langues.getSelectedIndex();

			if (indicateur != Logo.langage && indicateur != -1) {
				Logo.langage = indicateur;
				Logo.genere_langue(indicateur);
				cadre.setText();
				cadre.primitive.construis_treemap(indicateur);
				cadre.editeur = new Editeur(cadre);
				cadre.panneauHistorique1.bediteur.setText(Logo.messages
						.getString("editeur"));
				cadre.panneauHistorique1.bstop.setToolTipText(Logo.messages
						.getString("interrompre_execution"));
				cadre.panneauHistorique1.bediteur.setToolTipText(Logo.messages
						.getString("ouvrir_editeur"));
			}
			int taille = Integer.parseInt(panneau_police.taille_police
					.getText());

			Font font = Panneau_Police.fontes[panneau_police.jl_police
					.getSelectedIndex()].deriveFont((float) taille);
			Cadre.police = panneau_police.jl_police.getSelectedIndex();
			
			// Si l'on change la police de l'interface
			if (!Logo.police.equals(font)) {
				Logo.police = font;
				cadre.setText();
				cadre.panneauHistorique1.dsd.change_police_interface(font, taille);
			}
			
			if (effacer_editeur.isSelected())
				Logo.effacer_dessin = true;
			try {
				int i = Integer.parseInt(tortues.getText());
				Logo.tortues = i;
				Tortue[] tampon = (Tortue[]) cadre.tortues.clone();
				cadre.tortues = new Tortue[i];
				int borne_sup = 0;
				if (tampon.length < i || tampon.length == i)
					borne_sup = tampon.length;
				else
					borne_sup = i;
				for (int j = 0; j < tampon.length; j++) {
					cadre.tortues[j] = tampon[j];
				}
				for (int j = tampon.length; j < i; j++) {
					cadre.tortues[j] = null;
				}
			} catch (NumberFormatException e2) {
			}
			try {
				int i = Integer.parseInt(epaisseur.getText());
				Logo.epaisseur_max = i;
			} catch (NumberFormatException e1) {
			}
			Logo.forme_crayon = jc.getSelectedIndex();
			// Si on change la qulit du dessin:
			Logo.qualite=jc_qualite.getSelectedIndex();
			if (Logo.qualite==1) {
				cadre.primitive.g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
				cadre.primitive.g.setRenderingHint(RenderingHints.KEY_RENDERING,RenderingHints.VALUE_RENDER_QUALITY);
				cadre.primitive.g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
			}
			else if (Logo.qualite==2){
				cadre.primitive.g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_OFF);
				cadre.primitive.g.setRenderingHint(RenderingHints.KEY_RENDERING,RenderingHints.VALUE_RENDER_SPEED);
				cadre.primitive.g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,RenderingHints.VALUE_TEXT_ANTIALIAS_OFF);
			}
			else {
				cadre.primitive.g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_DEFAULT);
				cadre.primitive.g.setRenderingHint(RenderingHints.KEY_RENDERING,RenderingHints.VALUE_RENDER_DEFAULT);
				cadre.primitive.g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,RenderingHints.VALUE_TEXT_ANTIALIAS_DEFAULT);
			
			}
			// Si on redimensionne la zone de dessin
			try{
				boolean changement=false;
				int dim=Integer.parseInt(hauteur.getText());
				if (dim!=Logo.hauteur_dessin) changement=true;
				int tmp_hauteur=Logo.hauteur_dessin;
				Logo.hauteur_dessin=dim;
				dim=Integer.parseInt(largeur.getText());
				if (dim!=Logo.largeur_dessin) changement=true;
				int tmp_largeur=Logo.largeur_dessin;
				Logo.largeur_dessin=dim;
				if (Logo.largeur_dessin<100 || Logo.hauteur_dessin<100) {
					Logo.largeur_dessin=1000;
					Logo.hauteur_dessin=1000;
				}
				if (changement) {
					int memoire_necessaire=Logo.largeur_dessin*Logo.hauteur_dessin*4/1024/1024;
					int memoire_image=tmp_hauteur*tmp_largeur*4/1024/1024;
					long free=Runtime.getRuntime().freeMemory()/1024/1024;
					long total=Runtime.getRuntime().totalMemory()/1024/1024;
//					System.out.println("mmoire envisage "+(total-free+memoire_necessaire-memoire_image));
					if (total-free+memoire_necessaire-memoire_image<Logo.memoire*0.8){
						cadre.ardoise1.setVisible(false);
						cadre.primitive.g.dispose();
						cadre.primitive.graph.dispose();
						cadre.ardoise1.dessin.flush();
						cadre.ardoise1.dessin=null;
						System.gc();
						Logo.init(cadre);
						cadre.primitive.rafraichis();
						cadre.primitive.videecran();
						cadre.ardoise1.setPreferredSize(new Dimension(Logo.largeur_dessin,Logo.hauteur_dessin));
						cadre.ardoise1.revalidate();
						cadre.ardoise1.setVisible(true);
						Dimension d=cadre.jScrollPane1.getViewport().getViewRect().getSize();
						Point p=new Point(Math.abs(Logo.largeur_dessin/2-d.width/2),Math.abs(Logo.hauteur_dessin/2-d.height/2));
						cadre.jScrollPane1.getViewport().setViewPosition(p);
					}
					else{
						Logo.largeur_dessin=tmp_largeur;
						Logo.hauteur_dessin=tmp_hauteur;
						largeur.setText(String.valueOf(Logo.largeur_dessin));
						hauteur.setText(String.valueOf(Logo.hauteur_dessin));
						long conseil=64*((total-free+memoire_necessaire-memoire_image)/64)+64;
						if (total-free+memoire_necessaire-memoire_image>0.8*conseil) conseil+=64;
						if (conseil==Logo.memoire) conseil+=64;
						String message=Logo.messages.getString("erreur_memoire")+" "+conseil+"\n"+Logo.messages.getString("relancer");
						JTextArea jt=new JTextArea(message);
						jt.setEditable(false);
						jt.setBackground(new Color(255,255,177));
						jt.setFont(Logo.police);

				      JOptionPane.showMessageDialog(this,jt,Logo.messages.getString("erreur"),JOptionPane.ERROR_MESSAGE);
					}
				}
			}
			catch(NumberFormatException e1){
				Logo.largeur_dessin=1000;
				Logo.hauteur_dessin=1000;
			}
			Logo.tmp_memoire=Integer.parseInt(memoire.getText());
			if (Logo.tmp_memoire<64) Logo.tmp_memoire=64;
			Logo.vitesse = jSlider1.getValue();
			try { //Look and Feel
				if (windows.isSelected()) {
					//					UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
					UIManager.setLookAndFeel(UIManager
							.getSystemLookAndFeelClassName());
				} else if (java.isSelected()) {
					UIManager
							.setLookAndFeel(new javax.swing.plaf.metal.MetalLookAndFeel());
				} else if (motif.isSelected()) {
					UIManager
							.setLookAndFeel(new com.sun.java.swing.plaf.motif.MotifLookAndFeel());
				}
				SwingUtilities.updateComponentTreeUI(cadre);
				SwingUtilities.updateComponentTreeUI(cadre.editeur);
			} catch (Exception exc) {
				System.out.println(exc.toString());
			}
			int i = instrument.getSelectedIndex();
			if (i != -1)
				cadre.son.setInstrument(i);
			String chemin = "tortue";
			for (i = 0; i < 7; i++) {
				if (icone[i].num() != -1) {
					chemin += i + ".png";
					Logo.tortue_choisie = i;
					break;
				}
			}
			if (!chemin.equals("tortue")) {
				cadre.tortue.forme = Logo.tortue_choisie;
				change_image_tortue(cadre, chemin);
			}
			dispose();
			// On adapte la coloration syntaxique
			Logo.COLOR_ENABLED=panneau_coloration.Coloration_activee();
			if (Logo.COLOR_ENABLED) {
				Logo.coloration_commentaire=panneau_coloration.p_comment.color();
				Logo.coloration_operande=panneau_coloration.p_operande.color();
				Logo.coloration_primitive=panneau_coloration.p_primitive.color();
				Logo.coloration_parenthese=panneau_coloration.p_parenthese.color();
				Logo.style_commentaire=panneau_coloration.p_comment.style();
				Logo.style_operande=panneau_coloration.p_operande.style();
				Logo.style_primitive=panneau_coloration.p_primitive.style();
				Logo.style_parenthese=panneau_coloration.p_parenthese.style();
				// On attribue les styles slectionns  l'diteur 
			cadre.editeur.zonedition.dsd.initStyles(Logo.coloration_commentaire,Logo.style_commentaire,Logo.coloration_primitive,Logo.style_primitive,
					Logo.coloration_parenthese,Logo.style_parenthese,Logo.coloration_operande,Logo.style_operande);
			cadre.commande.dlc.initStyles(Logo.coloration_commentaire,Logo.style_commentaire,Logo.coloration_primitive,Logo.style_primitive,
					Logo.coloration_parenthese,Logo.style_parenthese,Logo.coloration_operande,Logo.style_operande);
			cadre.panneauHistorique1.dsd.initStyles(Logo.coloration_commentaire,Logo.style_commentaire,Logo.coloration_primitive,Logo.style_primitive,
					Logo.coloration_parenthese,Logo.style_parenthese,Logo.coloration_operande,Logo.style_operande);
			}
			cadre.editeur.zonedition.dsd.setColoration(Logo.COLOR_ENABLED);
			cadre.commande.dlc.setColoration(Logo.COLOR_ENABLED);
			cadre.panneauHistorique1.dsd.setColoration(Logo.COLOR_ENABLED);
			
			cadre.commande.setPreferredSize(new Dimension(300,Logo.police.getSize()*18/10));
			cadre.validate();
		} else
			dispose();
	}

	class Icone extends JToggleButton {
		int numero;

		Icone(int numero) {
			this.numero = numero;
			ImageIcon ic = new ImageIcon(Preference.class.getResource("tortue"
					+ numero + ".png"));
			this.setIcon(ic);
			if (numero == Logo.tortue_choisie)
				setSelected(true);
		}

		int num() {
			if (isSelected())
				return numero;
			return -1;
		}
	}

	
	  class Contenu extends JLabel implements ListCellRenderer{
	  	ImageIcon[] drapeau;
	  	Contenu(){
	  		setFont(Logo.police);
	  		drapeau=new ImageIcon[lang.length];
	  		cree_icone();	
	  	}
	  	void cree_icone(){
	  		for (int i=0;i<lang.length;i++){
	  		Image image=null;
  			image= Toolkit.getDefaultToolkit().getImage(Preference.class.getResource("drapeau"+i+".png"));
  			MediaTracker tracker=new MediaTracker(this);
  			tracker.addImage(image,0);
  			try{tracker.waitForID(0);}
  			catch(InterruptedException e1){}
  			int largeur=image.getWidth(this);
  			int hauteur=image.getHeight(this);
  			double facteur = (double)Logo.police.getSize()/(double)hauteur;
  			image=image.getScaledInstance((int)(facteur*largeur),(int)(facteur*hauteur),Image.SCALE_SMOOTH);
  			tracker=new MediaTracker(this);
			tracker.addImage(image,0);
			try{tracker.waitForID(0);}
			catch(InterruptedException e1){}
			drapeau[i]=new ImageIcon();
  			drapeau[i].setImage(image);
//			drapeau[i]=new ImageIcon(image);
	  		}
	  		
	  	}
	  	public Component getListCellRendererComponent(JList list, Object value,int 
	  index, boolean isSelected,boolean cellHasFocus){ 
	  		setOpaque(true);
	  		String s=value.toString(); 
	  		setText(s); 
	  		setIcon(drapeau[index]);
	  		if (isSelected) {
	  			setBackground(list.getSelectionBackground());
	  			setForeground(list.getSelectionForeground()); } 
	  		else{
	  			setBackground(list.getBackground());
	  			setForeground(list.getForeground()); 
	  		}
	  		setBorder(BorderFactory.createEmptyBorder(5,0,5,5));
//	  		setEnabled(list.isEnabled());
	 		return(this); 
	 		} 
	  	}
	 
	static void change_image_tortue(Cadre cadre, String chemin) {
		if (cadre.tortue.visible)
			cadre.primitive.montrecacheTortue();
		if (chemin.equals("tortue0.png")) {
			cadre.tortue.tort = null;
			cadre.tortue.largeur = 26;
			cadre.tortue.hauteur = 26;
		} else {
			//ON teste tout d'abord si le chemin est valide
			if (null == Tortue.class.getResource(chemin))
				chemin = "tortue1.png";
			cadre.tortue.tort = Toolkit.getDefaultToolkit().getImage(
					Tortue.class.getResource(chemin));
			MediaTracker tracker = new MediaTracker(cadre);
			tracker.addImage(cadre.tortue.tort, 0);
			try {
				tracker.waitForID(0);
			} catch (InterruptedException e1) {
			}
			double largeur_ecran = Toolkit.getDefaultToolkit().getScreenSize()
					.getWidth();
			// On fait attention  la rsolution de l'utilisateur
			double facteur = largeur_ecran / 1024.0;

			if ((int) (facteur + 0.001) != 1) {
				cadre.tortue.largeur = cadre.tortue.tort.getWidth(cadre);
				cadre.tortue.hauteur = cadre.tortue.tort.getHeight(cadre);
				cadre.tortue.tort = cadre.tortue.tort.getScaledInstance(
						(int) (facteur * cadre.tortue.largeur),
						(int) (facteur * cadre.tortue.hauteur),
						Image.SCALE_SMOOTH);
				tracker = new MediaTracker(cadre);
				tracker.addImage(cadre.tortue.tort, 0);
				try {
					tracker.waitForID(0);
				} catch (InterruptedException e1) {
				}
			}
			cadre.tortue.largeur = cadre.tortue.tort.getWidth(cadre);
			cadre.tortue.hauteur = cadre.tortue.tort.getHeight(cadre);
		}
		cadre.tortue.gabarit = Math.max(cadre.tortue.hauteur,
				cadre.tortue.largeur);
		if (cadre.tortue.visible)
			cadre.primitive.montrecacheTortue();

	}
}